﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Collections;

namespace TrakalMatej.Astar {
    public class Bod : IComparable {
        public Point Souradnice { get; set; }
        public HodnotaBodu Data { get; set; }
        public override string ToString() {
            return Data.ToString();
        }
        /// <summary>
        /// G: délka cesty od startu
        /// </summary>
        public double OhodnoceniGVzdalenostStart { get; set; }
        /// <summary>
        /// H: délka ohodnocení do cíle (heuristikou)
        /// </summary>
        public double OhodnoceniHNejCestaDoCile { get; set; }
        /// <summary>
        /// F: ohodnocení cesty VzdalenostStart + NejCestaDoCile
        /// </summary>
        public double OhodnoceniFNejCestaStartCil { get; set; }
        public bool Uzavren { get; set; }
        public Bod Rodic { get; set; }
        public int PoziceNaCeste { get; set; }

        public Bod() {
            this.Uzavren = false;
            this.OhodnoceniGVzdalenostStart = 0;
            this.Rodic = null;
        }
        public int CompareTo(object obj) {
            if (this.OhodnoceniHNejCestaDoCile < ((Bod)obj).OhodnoceniHNejCestaDoCile) {
                return -1;
            }
            if (this.OhodnoceniHNejCestaDoCile > ((Bod)obj).OhodnoceniHNejCestaDoCile) {
                return 1;
            }
            return 0;
        }
    }
}
