﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TrakalMatej.Astar;

namespace INZUI_01PSP {
    public partial class Robot : Form {
        Matice matice;
        Astar<HodnotaBodu> cesta;
        Point[] tahy = {new Point(1, -1), 
                        new Point(1, 0), 
                        new Point(1, 1), 
                        new Point(0, 1), 
                        new Point(-1, 1), 
                        new Point(-1, 0), 
                        new Point(-1, -1), 
                        new Point(0, -1),
                        };

        public Robot() {
            InitializeComponent();

            kresliciPlocha1.MouseClick += new MouseEventHandler(kresliciPlocha1_MouseClick);
            kresliciPlocha1.MouseMoveSpecial += new EventHandler(kresliciPlocha1_MouseMoveSpecial);

            radioButtonZed.Select();

            numericUpDownX.Value = 15;
            numericUpDownY.Value = 10;
            numericUpDownHeuristika.Value = 2;

            matice = new Matice((int)numericUpDownX.Value, (int)numericUpDownY.Value);

            #region dodání základních pozic
            matice[3, 0].Data = HodnotaBodu.plne;
            matice[4, 0].Data = HodnotaBodu.plne;
            matice[0, 1].Data = HodnotaBodu.plne;
            matice[1, 1].Data = HodnotaBodu.plne;

            matice[4, 3].Data = HodnotaBodu.plne;
            matice[5, 3].Data = HodnotaBodu.plne;
            matice[6, 3].Data = HodnotaBodu.plne;
            matice[7, 3].Data = HodnotaBodu.plne;

            matice[4, 4].Data = HodnotaBodu.plne;
            matice[7, 4].Data = HodnotaBodu.plne;

            matice[4, 5].Data = HodnotaBodu.plne;

            matice[8, 7].Data = HodnotaBodu.plne;
            matice[8, 8].Data = HodnotaBodu.plne;

            Point start = new Point(9, 8);
            Point cil = new Point(2, 0);

            matice[start.X, start.Y].Data = HodnotaBodu.start;
            matice[cil.X, cil.Y].Data = HodnotaBodu.cil;
            matice.Start = matice[start.X, start.Y];
            matice.Cil = matice[cil.X, cil.Y];
            #endregion

            vymazAZnovuAktivujCestu();

            prekresliPlochuBezCesty();
            //buttonNajdiCestu_Click(this, null);
        }

        void kresliciPlocha1_MouseMoveSpecial(object sender, EventArgs e) {
            /*
             * 
             * Called when the mouse moves to a different square.
             * 
             * */
            if (kresliciPlocha1 == null) {
                return;
            }
            Point point = kresliciPlocha1.Pozice;
            if (point.X == -1 || point.Y == -1) {
                return;
            }
            toolStripStatusLabel1.Text = String.Format("{6,-3} POS: {0,4}:{1,-4} G:{2,8:##0.000} H:{3,8:##0.000} F:{4,8:##0.000} {5,-8} ",
                matice[point.X, point.Y].Souradnice.X.ToString(),
                matice[point.X, point.Y].Souradnice.Y.ToString(),
                matice[point.X, point.Y].OhodnoceniGVzdalenostStart,
                matice[point.X, point.Y].OhodnoceniHNejCestaDoCile,
                matice[point.X, point.Y].OhodnoceniFNejCestaStartCil,
                matice[point.X, point.Y].Data,
                matice[point.X, point.Y].PoziceNaCeste);
        }

        void kresliciPlocha1_MouseClick(object sender, MouseEventArgs e) {
            if (kresliciPlocha1 == null) {
                return;
            }
            Point point = kresliciPlocha1.Pozice;
            if (point.X == -1 || point.Y == -1) {
                return;
            }
            if (e.Button == MouseButtons.Right) {
                /*
                 * 
                 * Right click isn't implemented!
                 * 
                 * */
                return;
            }
            if (matice[point.X, point.Y].Data == HodnotaBodu.prazdne) {
                switch (vkladatCo()) {
                    case HodnotaBodu.plne:
                        matice[point.X, point.Y].Data = HodnotaBodu.plne;
                        break;
                    case HodnotaBodu.start:
                        matice[matice.Start.Souradnice.X, matice.Start.Souradnice.Y].Data = HodnotaBodu.prazdne;
                        matice[point.X, point.Y].Data = HodnotaBodu.start;
                        matice.Start = matice[point.X, point.Y];
                        break;
                    case HodnotaBodu.cil:
                        matice[matice.Cil.Souradnice.X, matice.Cil.Souradnice.Y].Data = HodnotaBodu.prazdne;
                        matice[point.X, point.Y].Data = HodnotaBodu.cil;
                        matice.Cil = matice[point.X, point.Y];
                        break;
                }
            } else {
                matice[point.X, point.Y].Data = HodnotaBodu.prazdne;
            }
            /*
             if (_pathfinder.Squares[point.X, point.Y].ContentCode == SquareContent.Empty) {
                /*
                 * 
                 * Turn an empty square into a wall on click.
                 * 
                 * *
                _pathfinder.Squares[point.X, point.Y].ContentCode = SquareContent.Wall;
                Recalculate();
            } else if (_pathfinder.Squares[point.X, point.Y].ContentCode == SquareContent.Wall) {
                _pathfinder.Squares[point.X, point.Y].ContentCode = SquareContent.Empty;
                Recalculate();
            }
    */
            vymazAZnovuAktivujCestu();
            prekresliPlochuBezCesty();
            buttonNajdiCestu_Click(this, e);
        }

        private void Robot_Load(object sender, EventArgs e) {
        }

        private HodnotaBodu vkladatCo() {
            if (radioButtonZed.Checked) {
                return HodnotaBodu.plne;
            }
            if (radioButtonStart.Checked) {
                return HodnotaBodu.start;
            }
            if (radioButtonCil.Checked) {
                return HodnotaBodu.cil;
            }
            return HodnotaBodu.plne;
        }

        private void buttonNastavRozmery_Click(object sender, EventArgs e) {
            kresliciPlocha1 = null;
            kresliciPlocha1 = new KresliciPlocha((int)numericUpDownX.Value, (int)numericUpDownY.Value);
            kresliciPlocha1.Invalidate();
        }
        private void prekresliPlochuBezCesty() {
            for (int y = 0; y < matice.Vyska(); y++) {
                for (int x = 0; x < matice.Sirka(); x++) {
                    kresliciPlocha1.SetHighlight(barvaPlochy(matice[x, y]), x, y);
                }
            }
            kresliciPlocha1.Invalidate();
        }

        private Color barvaPlochy(Bod bod) {
            HodnotaBodu hodnotaBodu = bod.Data;
            switch (hodnotaBodu) {
                case HodnotaBodu.prazdne:
                    return bod.Uzavren ? Color.OldLace : Color.White;
                case HodnotaBodu.plne:
                    return Color.Gainsboro;
                case HodnotaBodu.start:
                    return Color.LightSeaGreen;
                case HodnotaBodu.cil:
                    return Color.LightGreen;
                case HodnotaBodu.aktualni:
                    return Color.Lime;
                case HodnotaBodu.zkoumane:
                    return Color.MediumSlateBlue;
                case HodnotaBodu.projite:
                    return Color.Moccasin;
                default:
                    return Color.DeepPink;
            }
        }

        private void buttonNajdiCestu_Click(object sender, EventArgs e) {
            LinkedList<Bod> ll = new LinkedList<Bod>();

            if ((ll = cesta.NalezenaCesta()) != null) {
                //prekresliPlochuBezCesty();
                foreach (Bod item in ll) {
                    if (item.Data == HodnotaBodu.start || item.Data == HodnotaBodu.cil) {
                        continue;
                    }
                    kresliciPlocha1.SetHighlight((item.Data == HodnotaBodu.plne) ? Color.DarkRed : Color.LightSkyBlue, item.Souradnice.X, item.Souradnice.Y);
                    kresliciPlocha1.Invalidate();
                }
                return;
            }
            toolStripStatusLabel1.Text = "Nenalezena cesta!";
        }

        private void buttonKrok_Click(object sender, EventArgs e) {
            cesta.Next();
            prekresliPlochuBezCesty();
        }

        private void numericUpDownHeuristika_ValueChanged(object sender, EventArgs e) {
            vymazAZnovuAktivujCestu();
        }

        private void vymazAZnovuAktivujCestu() {
            cesta = null;
            cesta = new Astar<HodnotaBodu>(matice, tahy, (int)numericUpDownHeuristika.Value);
            prekresliPlochuBezCesty();
        }


    }
}
